// This time around, we'll scroll a background...

// Includes
#include <PA9.h>       // Include for PA_Lib



// Graphics Includes
// *** Backgrounds ***
// gfx2gba -fsrc -m -pbg.pal -t8 *.bmp

#include "gfx/BG3.map.c" //background files
#include "gfx/BG3.raw.c"
#include "gfx/bg.pal.c" // palette file for the background




// Function: main()
int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
	
	// Load Palettes
	PA_LoadPal(PAL_BG0, bg_Palette); // Backgrounds
	PA_LoadPal(PAL_BG1, bg_Palette); // Backgrounds
	
	PA_InitText(1, 0); // Init text on the top screen, background 0...
	
	// Load Backgrounds
	PA_LoadSimpleBg(0, // screen
					3, // background number (0-3)
					BG3_Tiles, // name of the background tiles given by gfx2gba
					BG3_Map, // same thing for the map
					BG_256X256, // background size (can also be 512X256, 256X512, or 512X512
					0, // Leave this to 0 :)  only used for rotating backgrounds
					1); // 256 color mode... set to 0 for 16 color mode
	PA_LoadSimpleBg(1, 3, BG3_Tiles, BG3_Map, BG_256X256, 0, 1);
	
	s32 scrollx = 0; // No X scroll by default...
	s32 scrolly = 0; // No Y scroll by default...

	// Infinite loop to keep the program running
	while (1)
	{
		// We'll modify scrollx and scrolly according to the keys pressed
		scrollx += (Pad.Held.Left - Pad.Held.Right) * 4; // Move 4 pixels per press
		scrolly += (Pad.Held.Up - Pad.Held.Down) * 4; // Move 4 pixels per press

		// Scroll the background to scrollx, scrolly...
		PA_BGScrollXY(0, // Screen
					3, // Background number
					scrollx, // X scroll
					scrolly); // Y scroll
		
		// Display the X and Y scrolls :
		PA_OutputText(1, 0, 0, "x : %d   \ny : %d   ", scrollx, scrolly);
		
		PA_WaitForVBL();
	}
	
	return 0;
} // End of main()
